org.eclipse.rdf4j.query.algebra

## Class BinaryTupleOperator

- java.lang.Object
- - org.eclipse.rdf4j.query.algebra.AbstractQueryModelNode
  - - org.eclipse.rdf4j.query.algebra.BinaryTupleOperator

- All Implemented Interfaces:
    Serializable, Cloneable, GraphPatternGroupable, QueryModelNode, TupleExpr, VariableScopeChange
  Direct Known Subclasses:
    Difference, Intersection, Join, LeftJoin, Union

      public abstract class BinaryTupleOperator
      extends AbstractQueryModelNode
      implements TupleExpr

  An abstract superclass for binary tuple operators which, by definition, has two arguments.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected TupleExpr` | `leftArg` The operator's left argument.
    `protected TupleExpr` | `rightArg` The operator's right argument.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BinaryTupleOperator()`
    `protected` | `BinaryTupleOperator(TupleExpr leftArg, TupleExpr rightArg)` Creates a new binary tuple operator.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `BinaryTupleOperator` | `clone()` Returns a (deep) clone of this query model node.
    `boolean` | `equals(Object other)` Returns `true` if this query model node and its children are recursively equal to `o` and its children.
    `String` | `getAlgorithmName()`
    `TupleExpr` | `getLeftArg()` Gets the left argument of this binary tuple operator.
    `TupleExpr` | `getRightArg()` Gets the right argument of this binary tuple operator.
    `int` | `hashCode()`
    `void` | `replaceChildNode(QueryModelNode current, QueryModelNode replacement)` Default implementation of `QueryModelNode.replaceChildNode(QueryModelNode, QueryModelNode)` that throws an `IllegalArgumentException` indicating that `current` is not a child node of this node.
    `void` | `setAlgorithm(Iteration<BindingSet,QueryEvaluationException> iteration)`
    `void` | `setLeftArg(TupleExpr leftArg)` Sets the left argument of this binary tuple operator.
    `void` | `setRightArg(TupleExpr rightArg)` Sets the right argument of this binary tuple operator.
    `<X extends Exception> void` | `visitChildren(QueryModelVisitor<X> visitor)` Dummy implementation of `QueryModelNode.visitChildren(org.eclipse.rdf4j.query.algebra.QueryModelVisitor<X>)` that does nothing.

    - ### Methods inherited from class org.eclipse.rdf4j.query.algebra.AbstractQueryModelNode

      `getCostEstimate, getParentNode, getResultSizeActual, getResultSizeEstimate, getSignature, getTotalTimeNanosActual, isGraphPatternGroup, isVariableScopeChange, nullEquals, replaceNodeInList, replaceWith, setCostEstimate, setGraphPatternGroup, setParentNode, setResultSizeActual, setResultSizeEstimate, setTotalTimeNanosActual, setVariableScopeChange, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.query.algebra.TupleExpr

      `getAssuredBindingNames, getBindingNames`

    - ### Methods inherited from interface org.eclipse.rdf4j.query.algebra.QueryModelNode

      `getCostEstimate, getParentNode, getResultSizeActual, getResultSizeEstimate, getSignature, getTotalTimeNanosActual, replaceWith, setCostEstimate, setParentNode, setResultSizeActual, setResultSizeEstimate, setTotalTimeNanosActual, toString, visit`

- - ### Field Detail

    - #### leftArg

          protected TupleExpr leftArg

      The operator's left argument.

    - #### rightArg

          protected TupleExpr rightArg

      The operator's right argument.

  - ### Constructor Detail

    - #### BinaryTupleOperator

          protected BinaryTupleOperator()

    - #### BinaryTupleOperator

          protected BinaryTupleOperator(TupleExpr leftArg,
                                        TupleExpr rightArg)

      Creates a new binary tuple operator.
      Parameters:
        `leftArg` - The operator's left argument, must not be `null`.
        `rightArg` - The operator's right argument, must not be `null`.

  - ### Method Detail

    - #### getLeftArg

          public TupleExpr getLeftArg()

      Gets the left argument of this binary tuple operator.
      Returns:
        The operator's left argument.

    - #### setLeftArg

          public void setLeftArg(TupleExpr leftArg)

      Sets the left argument of this binary tuple operator.
      Parameters:
        `leftArg` - The (new) left argument for this operator, must not be `null`.

    - #### getRightArg

          public TupleExpr getRightArg()

      Gets the right argument of this binary tuple operator.
      Returns:
        The operator's right argument.

    - #### setRightArg

          public void setRightArg(TupleExpr rightArg)

      Sets the right argument of this binary tuple operator.
      Parameters:
        `rightArg` - The (new) right argument for this operator, must not be `null`.

    - #### visitChildren

          public <X extends Exception> void visitChildren(QueryModelVisitor<X> visitor)
                                                   throws X extends Exception

      Description copied from class: `AbstractQueryModelNode`
      Dummy implementation of `QueryModelNode.visitChildren(org.eclipse.rdf4j.query.algebra.QueryModelVisitor<X>)` that does nothing. Subclasses should override this method when they have child nodes.
      Specified by:
        `visitChildren` in interface `QueryModelNode`
      Overrides:
        `visitChildren` in class `AbstractQueryModelNode`
      Throws:
        `X extends Exception`

    - #### replaceChildNode

          public void replaceChildNode(QueryModelNode current,
                                       QueryModelNode replacement)

      Description copied from class: `AbstractQueryModelNode`
      Default implementation of `QueryModelNode.replaceChildNode(QueryModelNode, QueryModelNode)` that throws an `IllegalArgumentException` indicating that `current` is not a child node of this node.
      Specified by:
        `replaceChildNode` in interface `QueryModelNode`
      Overrides:
        `replaceChildNode` in class `AbstractQueryModelNode`
      Parameters:
        `current` - The current child node.
        `replacement` - The new child node.

    - #### equals

          public boolean equals(Object other)

      Description copied from interface: `QueryModelNode`
      Returns `true` if this query model node and its children are recursively equal to `o` and its children.
      Specified by:
        `equals` in interface `QueryModelNode`
      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### clone

          public BinaryTupleOperator clone()

      Description copied from interface: `QueryModelNode`
      Returns a (deep) clone of this query model node. This method recursively clones the entire node tree, starting from this nodes.
      Specified by:
        `clone` in interface `QueryModelNode`
      Specified by:
        `clone` in interface `TupleExpr`
      Overrides:
        `clone` in class `AbstractQueryModelNode`
      Returns:
        A deep clone of this query model node.

    - #### setAlgorithm

          @Experimental
          public void setAlgorithm(Iteration<BindingSet,QueryEvaluationException> iteration)

    - #### getAlgorithmName

          @Experimental
          public String getAlgorithmName()

Copyright © 2015-2021 Eclipse Foundation. All Rights Reserved.